/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

#define MAX_FILE_PATH    256

/* The correlation coefficient is used for the lambda-p model.            */
/* This is the default value for the simL pedigree data file.             */
/* The coefficient need to be recomputed for other pedigrees.             */
/* A function to compute the coeffiecient will be added to Morgan in      */
/* the near future.                                                       */
#define CORR 0.02            

enum STAT_MEAS
{ SPAIRS, SROBDOM, SAFFUNAFF, SLAMBDA, MAXFGL, LAMBDA_P, DELTA };
enum STAT_TESTS
{ NORMAL, PERMUTATION, CHISQUARE };
enum STAT_TYPE
{ STAT_MEAN, STAT_ANDERSON, STAT_QUANTILE };

int   bResimuEnable;
int   nStatType = STAT_MEAN;
double *pQuantileList = NULL;

extern int ***Allocation_Matrix;
extern int ***matry;
extern int ***Share_Alleles;
extern int **size_aff;
extern int **size_unaff;
extern int **Size;
extern int *Group;
extern int **Affect_resimulation;

typedef struct
{
   int   allele_info;
   double allocation;
   int   status;
} founder;
typedef struct tnode
{
   int   number;
   struct tnode *next;
} node;

double Calculate_Likelihood (int, int, int *, int, double, double, double, int);
uint32 lran (void);
void  Weight_Multilambda (double *);
