/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

int use_lsmpl_setup (void)              /* use locus-by-locus samp for setup  */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (SmplSetup == SEQIMP)
         err_typ = ERR_SSU;
      SmplSetup = INDEP_LOC;
   }

   return err_typ;
}

int use_sqimp_setup (void)              /* use sequential imputatn for setup  */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (SmplSetup == INDEP_LOC)
         err_typ = ERR_SSU;
      SmplSetup = SEQIMP;
   }

   return err_typ;
}

int use_sqimp_realz (void)              /* use I sequential imputation realiz */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (j_par[0] < 0)
         err_typ = ERR_NSI;
      NSeqImp = j_par[0];
   }

   return err_typ;
}

int use_full_em (void)                  /* use full (regular) em              */
{
   if (chk_stat ())
   {
      chk_repeat ();
      IPtEM = FALSE;
   }

   return err_typ;
}

int use_part_em (void)                  /* use partitioned em                 */
{
   if (chk_stat ())
   {
      chk_repeat ();
      IPtEM = TRUE;
   }

   return err_typ;
}

int use_hybrd_maxi (void)               /* use hybrid algor for maximization  */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (MaximAlgo != UNDEF)
         err_typ = ERA_MXA;
      MaximAlgo = HYBRID;
   }

   return err_typ;
}

int use_mcem_maxi (void)                /* use MCEM for maximization          */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (MaximAlgo != UNDEF)
         err_typ = ERA_MXA;
      MaximAlgo = MCEM;
   }

   return err_typ;
}

int use_exact_summation (void)          /* use exact summation for trait      */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (UseMCSummation != UNDEF)
         err_typ = ERA_UST;
      UseMCSummation = FALSE;
   }

   return err_typ;
}

int use_mc_summation (void)             /* use MC summation for trait         */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (UseMCSummation != UNDEF)
         err_typ = ERA_UST;
      UseMCSummation = TRUE;
   }

   return err_typ;
}

int use_mc_realizations (void)          /* use I MC realizations for trait    */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (j_par[0] <= 0)
         err_typ = ERA_MRT;
      MCRealizations = j_par[0];
   }

   return err_typ;
}

int use_mulplier_for_null (void)        /* use multiplier I MC realiz for null */
{
   if (chk_stat ())
   {
      chk_repeat ();
      if (j_par[0] <= 0)
         err_typ = ERA_MRN;
      MultiplierForNull = j_par[0];
   }

   return err_typ;
}
