/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/*
 * $Id: genotrace.c,v 1.2 2005-08-14 00:22:12 thompson Exp $
 */

/* Disclaimer: No global variables used in these functions */

static int recode_geno (int a1, int a2, int na)
{
   int   tmp = a1;
   if (a1 > a2)
   {
      a1 = a2;
      a2 = tmp;
   }
   return (a1 - 1) * na + a2;
}

/**
 * Dumping debug infomation after each iteration, currently encoded genotypes
 * for each individual
 *
 * Parameters:
 *
 *     1.  Pointer to dump file
 *     2.  Array of loci.
 *     3.  No. of loci
 *     4.  Pedigree size
 */
static void genotrace (FILE * fdbg, const struct Locus *myloci,
                       int mynloci, int mypdsize)
{
   int   jk;
   int   kk;

   /* print integer-coded genotypes of all individuals across all
    * loci in blocks by marker */
   fprintf (fdbg, "\n");
   for (jk = 0; jk < mynloci; ++jk)
   {
      for (kk = 0; kk < mypdsize; ++kk)
      {
         fprintf (fdbg, "%d ", recode_geno (myloci[jk].gt[0][kk],
                                            myloci[jk].gt[1][kk],
                                            myloci[jk].n_all));
      }
   }
}

/* {{{ Log */
/*
 * $Log: genotrace.c,v $
 * Revision 1.2  2005-08-14 00:22:12  thompson
 * Adding copyright statement at file head.
 *
 * Revision 1.1  2002/02/05 22:30:05  nali
 * Schnell has been brought up-to-date to fully use
 * MORGAN statements and character names, etc..
 *
 * To Do:
 * 1.  Checking results, comparing with Vitesse.
 * 2.  Fix restart problem
 * 3.  How to print diagnosis info?
 * 4.  Can't compute Pr (penetrance) yet.
 *
 */
/* }}} */
