/*  routines included in gl_lods programs, mainly for processing 
 * DGL file  etc.
 */

void dgl_index ()
/* First we will go through one cycle of DGL graph, and find index in nghd.
   If not in nghd we will drop; if in nghd but with 0 index, we will drop.
   We will set up to indicate in nghd which are found;
     then go through nghds to check all obsved have been found--else WARN*/
{
   int   i, id, j, sw, err;

   int  *nghd_index;
   char  nam1[MAXNAMLEN + 1], nam2[MAXNAMLEN + 1];
   FILE *fp;

   DGL_names = malloc (PedSize * sizeof (char *));
   alloc_chk (WHERE, DGL_names);
   for (i = 0; i < PedSize; ++i)
   {
      DGL_names[i] = malloc ((MAXNAMLEN + 1) * sizeof (char));
      alloc_chk (WHERE, DGL_names[i]);
   }
   DGL_index = malloc (PedSize * sizeof (int));

   nghd_index = malloc (pedsize * sizeof (int));
   for (i = 0; i < pedsize; ++i)
      nghd_index[i] = 0;

   if (!(fp = open_fil (XTRA)))         /* This is raw DGL graphs  */
      give_up (ERR_qit);

   for (i = 0; i < PedSize; ++i)        /* going through DGLgraph */
   {
      read_name2 (fp, nam1, &err);
      fscanf (fp, " %*d %*d %d", &sw);
      for (j = 0; j < sw; ++j)
         fscanf (fp, " %*d %*d");
      read_name2 (fp, nam2, &err);
      fscanf (fp, " %*d %*d %d", &sw);
      for (j = 0; j < sw; ++j)
         fscanf (fp, " %*d %*d");
      fflush (stdout);
      if (!strncmp (nam1, nam2, MAXNAMLEN + 1))
         strncpy (DGL_names[i], nam1, MAXNAMLEN + 1);
      else
      {
         printf ("\n paired names %s and %s in DGL file do not match",
                 nam1, nam2);
         exit (97);
      }
      id = get_posit (nam1);
      if (id == INVALID_INDEX)
         DGL_index[i] = INVALID_INDEX;
      else
      {
         nghd_index[id] = 1;
         if (nghd[id].obs)
            DGL_index[i] = id;
         else
            DGL_index[i] = INVALID_INDEX;
      }
   }

   read_name2 (fp, nam1, &err);         /* check next name is name 0 */
   if (strncmp (nam1, DGL_names[0], MAXNAMLEN + 1))
   {
      printf ("\n next name %s does not match first name %s in DGL file",
              nam1, DGL_names[0]);
      exit (97);
   }

   for (i = 0; i < pedsize; ++i)        /* now check nghd_index[]   */
      if ((nghd_index[i] == 0) && (nghd[i].obs == 1))
      {
         nghd[i].obs = 0;
         printf ("\n Observed individual %s is not in DGL file:", nghd[i].self);
         printf ("\n    Trait data on %s will be ignored (W)\n ", nghd[i].self);
      }

   fclose (fp);
   return;
}

int copy_line (FILE * fp_in, FILE * fp_out, int tt, int ii)
{
   int   j, id, k, sw, item, cc, err;
   char  nam1[MAXNAMLEN + 1];

   cc = 0;
   id = DGL_index[ii];
   if (id == INVALID_INDEX)
      for (j = 0; j < 2; ++j)
      {
         if (read_name2 (fp_in, nam1, &err) == EOF)
         {
            cc = -1;
            return cc;
         }
         fscanf (fp_in, " %*d %*d %d", &sw);
         for (k = 0; k < sw; ++k)
            fscanf (fp_in, " %*d %*d");
      }
   else
   {
      for (j = 0; j < 2; ++j)
      {
         if (read_name2 (fp_in, nam1, &err) == EOF)
         {
            cc = -1;
            return cc;
         }
         if (strncmp (nam1, nghd[id].self, MAXNAMLEN + 1))
         {
            printf
               ("\n Problem: name %s does not match %s at DGL posit %d in graph %d",
                nam1, nghd[id].self, ii, tt);
            exit (97);
         }
         fprintf (fp_out, " %d", id);
         for (k = 0; k < 2; ++k)
         {
            fscanf (fp_in, " %d", &item);
            fprintf (fp_out, " %d", item);
         }
         if (item > cc)
            cc = item;

         fscanf (fp_in, " %d", &sw);
         fprintf (fp_out, " %d", sw);
         for (k = 0; k < sw; ++k)
         {
            fscanf (fp_in, " %d", &item);
            fprintf (fp_out, " %d", item); /* switch point  */
            fscanf (fp_in, " %d", &item);
            fprintf (fp_out, " %d", item); /* switch FGL    */
            if (item > cc)
               cc = item;
         }
         fprintf (fp_out, " \n");
      }
   }

   return cc;
}

int dgl_strip (int *n_dgl)
/* Now we go through the DGL graph file again, stripping unobserved individuals
 * and outputting again by pedigree index; also track largest fgl for nFGL
 */
{
   int   i, t, cc, ctot, max_fgl;
   FILE *fp, *oScorF;

   ctot = 0;
   max_fgl = 0;

   if (!(fp = open_fil (XTRA)))         /* This is raw DGL graphs  */
      give_up (ERR_qit);

   if (!(oScorF = open_fil (OSCORE)))   /* This is processed DGL graphs  */
      give_up (ERR_qit);

   for (t = 0; t < NIt; ++t)            /*  NIt DGL graphs in the file */
   {
      for (i = 0; i < PedSize; ++i)     /* going through DGLgraph */
      {
         cc = copy_line (fp, oScorF, t, i); /* return max fgl no */
         if (cc < 0)
            break;
         if (cc > max_fgl)
            max_fgl = cc;
         if (cc > 0)
            ++ctot;
      }
      if (cc < 0)
         break;
   }

   *n_dgl = t;                          /* number dgl grphs read */

   ctot = ctot / (*n_dgl);              /* number individuals per new grph */
   nFGL = max_fgl;                      /* reset nFGL   */

   fclose (fp);
   fclose (oScorF);
   return ctot;
}

void set_line (FILE * fp, int **ggg)
{
   int   j, k, id, fgl, fgl2, sw, swp;

   fscanf (fp, " %d %*d %d %d", &id, &fgl, &sw);
   if (!sw)
      for (j = 0; j < NMarks; ++j)
         ggg[j][id] = fgl;

   else
   {
      j = 0;
      for (k = 0; k < sw; ++k)
      {
         fscanf (fp, "%d %d", &swp, &fgl2);
         while ((j < NMarks) && (MarSel[j] < swp))
         {
            ggg[j][id] = fgl;
            ++j;
         }
         fgl = fgl2;
      }
      while (j < NMarks)
      {
         ggg[j][id] = fgl;
         ++j;
      }

   }
   return;
}

void check_fgl ()
{
   int   i, j;

   for (i = 0; i < pedsize; ++i)
      if (nghd[i].obs)
      {
         printf ("\n %d %s", nghd[i].index, nghd[i].self);
         for (j = 0; j < NMarks; ++j)
            printf (" %d", gg0[j][i]);
         printf ("   ");
         for (j = 0; j < NMarks; ++j)
            printf (" %d", gg1[j][i]);
      }
   printf ("\n");
}

void fgl_set (FILE * fp, int c_fgl)
{
   int   i;

   for (i = 0; i < c_fgl; ++i)
   {
      set_line (fp, gg0);
      set_line (fp, gg1);
   }

   check_fgl ();

   return;
}
