/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/* This whole file is a kludge.  For now it reads parameters in from an       */
/* "input extra file" named parameter file.  These all need to be replaced    */
/* by parameter statements.

 Temporary subroutine for setting parameters of lm_twoqtl.

 PARAMETERS                   Parameter Statements

  sim_freq_1 = X1              set tloc  I1  simulation allele frequencies  X1 X2
  sim_freq_2 = X1              set tloc  I2  simulation allele frequencies  X1 X2

  seed = X1 X2                 set trait seeds  X1 X2

  debug_level = I1             set debug level  I1

 YJS Jul 1, 2005.                                                             */

#include "twoqtl.h"

int is_twoqtl_parm_int (char *key)
{
   if (strncmp (key, "debug_level", 20) == 0)
      return TRUE;
   else
      return FALSE;
}

void set_twoqtl_parm (void)
{
   char  line[50], key[30];
   FILE *iXtra;

   double dbl[3];

   unsigned int cseed, tseed;
   int   scan_count;

   if (!(iXtra = open_fil (XTRA)))
      give_up (ERR_qit);

   fprintf (stdout, "... set parameters for lm_twoqtl (TEMP) ...\n\n");

   while (fgets (line, sizeof (line), iXtra) != NULL)
   {
      scan_count =
         sscanf (line, "%s %lf %lf %lf", key, &dbl[0], &dbl[1], &dbl[2]);

      if (scan_count == 2)
      {
         if (is_twoqtl_parm_int (key) == TRUE)
         {
            set_twoqtl_parm_int (key, (int) dbl[0]);
            fprintf (stdout, " %s: %3d\n", key, (int) dbl[0]);
         }
      }

      else
      {
         scan_count = sscanf (line, "%s %x %x", key, &cseed, &tseed);

         if ((scan_count == 3) && (strncmp (key, "seed", 20) == 0))
         {
            setsd_alt (cseed, tseed);
            fprintf (stdout, " %s: %08x %08x\n", key, cseed, tseed);
         }
      }
   }

   if (ferror (iXtra))
   {
      fprintf (stderr, "Error occurred while reading extra input file\n");
      exit (EXIT_FAILURE);
   }
   fclose (iXtra);

   fprintf (stdout, "\n... parameter setting for lm_twoqtl done (TEMP) ...\n");
   fprintf (stdout, "\n\n");

   return;
}
