/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */

/*
 NAME
    set_twoqtl_parm_int

 SYNOPSIS

    set_twoqtl_parm_int (char *key, int value);

 DESCRIPTION

    Set functions need to be called by Myrna to process parameter statements.
    Get functions get these parameters.

 AUTHOR
    Written by Yun Ju Sung.

 HISTORY
    Documented.                                      Jul  1, 2005
    Make default values for some parameters.         Aug 25, 2005

*/

#include "twoqtl.h"

void set_twoqtl_parm_int (char *key, int value)
{
   if (strncmp (key, "debug_level", 20) == 0)
   {
      if (value < 0)
         give_up (ERR_err, "\n debug_level must be non-negative ");
      debug_level = value;
      return;
   }

   give_up (ERR_err, "\n set_twoqtl_parm_int: key not recognized ");
}
